module Main where

import Control.Exception
import System.Environment
import System.Win32.DLL
import System.Win32.Service
import System.Win32.Types

uninstallService :: String -> IO ()
uninstallService serviceName = do
  bracket
    (openSCManager Nothing Nothing sC_MANAGER_CONNECT)
    (closeServiceHandle)
    $ \hScm -> do
      bracket
        (openService hScm serviceName dELETE)
        (closeServiceHandle)
        $ \hService -> do
          deleteService hService

startService :: String -> IO () -> IO () -> IO ()
startService serviceName fServiceMain fServiceStop = do
  return ()

installAsService :: String -> String -> String -> Maybe String -> IO ()
installAsService
  serviceName displayName commandLineArguments dependencies = do
    moduleFilename <- getModuleFileName nullHANDLE
    putStrLn $ "Opening SC Manager in " ++ moduleFilename
    let commandLine = moduleFilename ++ " " ++ commandLineArguments
    bracket
      (openSCManager Nothing Nothing sC_MANAGER_ALL_ACCESS)
      (closeServiceHandle)
      $ \hScm -> do
        putStrLn $ "SC Manager handle is " ++ show hScm
        bracket
          ( createService
              hScm serviceName displayName sERVICE_CHANGE_CONFIG
              sERVICE_WIN32_OWN_PROCESS sERVICE_AUTO_START
              sERVICE_ERROR_NORMAL commandLine Nothing nullPtr
              dependencies Nothing Nothing )
          ( closeServiceHandle )
          $ \hService -> return ()
    putStrLn "Done."

serviceMain :: IO ()
serviceMain = return ()

serviceStop :: IO ()
serviceStop = return ()

main = do
  args <- getArgs
  case args of
    ["-install"] -> do
      putStrLn "Installing as service"
      installAsService "Haskell Service" "Haskell Service" "-service" Nothing
    ["-uninstall"] -> do
      putStrLn "Uninstalling as service"
      uninstallService "Haskell Service"
    ["-service"] -> do
      putStrLn "Running service"
      startService "Haskell Service" serviceMain serviceStop
    otherwise ->
      putStrLn "No change"

